% %lsqcurvefit
tic
% VariablesHighBPowderIB %don't forget to change prod_num
% xname=['SH SRR ktsi'];
% x0=[0.02 0.4737 0.0351]; %starting values for estimating
% lb=[0 0 0];
% ub=[inf 1 inf];

% VariablesHighBFloretsIB %don't forget to change prod_num
% xname=['SH SRR ke ktsi'];
% x0=[0.02 0.2737 0.024 0.0351]; %starting values for estimating
% lb=[0 0 0 0];
% ub=[inf 1 inf inf];

% VariablesHighBFloretsIB %don't forget to change prod_num
% xname=['SH SRR ktsi'];
% x0=[0.02 0.4737 0.0351]; %starting values for estimating
% lb=[0 0 0];
% ub=[inf 1 inf];

% VariablesMedBFloretsSR %don't forget to change prod_num
% xname=['SH SRR kf ke ktsi ktli keni'];
% x0=[0.1811,0.2037,0.0167,0.007,0.0078,0.382,0.000623]; %starting values for estimating
% lb=[0 0 0 0 0 0 0];
% ub=[inf 1 inf inf inf inf inf];

% VariablesLowBFloretsSR %don't forget to change prod_num
% xname=['SH SRR kf ke ktsi ktli keni'];
% x0=[0.02 0.4737 0.0033 0.024 0.0352 0.27 0.0015]; %starting values for estimating
% lb=[0 0 0 0 0 0 0];
% ub=[inf 1 inf inf inf inf inf];

% VariablesNoBFloretsIB %don't forget to change prod_num
% xname=['SH kf ke ktsi ktli keni'];
% x0=[0.02 0.0023 0.0024 0.00351 0.027 0.015]; %starting values for estimating
% lb=[0 0 0 0 0 0];
% ub=[inf inf inf inf inf inf];

%%
% global pdata a prod_num xdata ydata;  %current best set of parameters is minx 
% prod_num=3; %%% number representing product (i.e. 1=NoBF, 2=LowBF,3=MedBF, 4=HighBF, 5=HighBP)
% path='C:\Users\qucha\Documents\MATLAB\ThesisData\Results\';
% p={'a' 'b' 'c' 'd' 'e' 'f' 'g' 'h' 'i' 'l' 'm' 'n' 'o' 'p' 'q'};
% figure
% for k=4:4 %***
%     load(['C:\Users\qucha\Documents\MATLAB\p_' p{k} '.mat']) %loads raw data
%     disp(['C:\Users\qucha\Documents\MATLAB\p_' p{k} '.mat'])
%     colors='kgbrm';
%     for i = 1:5    
%         a(i)=plot(pdata{i}(:,1),pdata{i}(:,2),[colors(i)]); %plotted participant data plotted stored in a  
%         if i~=prod_num
%             set(a(i),'visible','off') %turns off/does not plot other products data
%         end
%         if k==14 && i==1, a(i)=-1; continue, end %skipping over NoBF data for participant p
%         pdata{i}(isnan(pdata{i}))=0; %if NaN exits in data, it is converted 0
%         hold on
%         if i==prod_num
%             plot(pdata{i}(:,1),pdata{i}(:,2),[colors(i) 's:']) %plots participant data for all 5 products
%             errorbar(pdata{i}(:,1),pdata{i}(:,2),(0.11505.*(pdata{i}(:,2)).^-0.24).*pdata{i}(:,2),[colors(i) 's:']);
%         end       
%        drawnow 
%     end
% %     drawnow
%     xdata=pdata{prod_num}(:,1);
%     ydata=pdata{prod_num}(:,2);
%      
%     if prod_num==1 && k==14, continue, end
%     title(p{k})
% %     try 
%     options = optimoptions(@lsqcurvefit,'FunctionTolerance',1e-10);
%     [x,resnorm,residual,exitflag,output,lambda,J]=lsqcurvefit(@lsqfitfun,x0,xdata,ydata,lb,ub,options); 
%     ci = nlparci(x,residual,'Jacobian',J,'alpha',.1);
%     MSE = (residual'*residual)/(size(ydata,1)-size(x,2));
%     CovMatrix =(J'*J)*MSE;
% %%%% Calculating correlation matrix from covariance matrix:
%     DiagCov = 1./sqrt(diag(CovMatrix));
%     DiagCorr = spdiags(DiagCov,0,size(x,2),size(x,2));
%     CorrMatrix = DiagCorr * CovMatrix * DiagCorr;
%     FullCorrMatrix = full(CorrMatrix);
%     
%     dt=datestr(datetime('now'));
%     dt(dt==':')='-'; %changes every colon in dt to a dash
%     save([path 'presult_' p{k} '.mat'],...
%         'x','resnorm','residual','exitflag','output','lambda','J','ci','MSE','CovMatrix','DiagCov',...
%         'DiagCorr','CorrMatrix','FullCorrMatrix','xname')
%     savefig([path 'presult_' p{k} '.fig']);
% %     catch ME
% %       disp(['***trouble with participant_' p{k}])
% %       rethrow(ME)
% %     end
%     hold off
% end
% toc  %tic toc tells time it took for model fitting

%%
% %FOR SR COMPOUND

global pdata a prod_num xdata ydata;  
prod_num=5; %%% number representing product (i.e. 1=NoBF, 2=LowBF,3=MedBF, 4=HighBF, 5=HighBP)
path='C:\Users\qucha\Documents\MATLAB\ThesisData\Results\'; %%path for where to save results
p={'a' 'b' 'c' 'd' 'e' 'f' 'g' 'h' 'i' 'l' 'm' 'n' 'o' 'p' 'q'};
figure
for k=1:15 %***
    load(['C:\Users\qucha\Documents\MATLAB\p_' p{k} '.mat']) %loads raw data
    disp(['C:\Users\qucha\Documents\MATLAB\p_' p{k} '.mat'])
    colors='kgbrm';
    for i = 1:5    
        a(i)=plot(pdata{i}(:,1),pdata{i}(:,3),[colors(i)]); %plotted participant data stored in variable 'a'  
        if i~=prod_num
            set(a(i),'visible','off') %turns off/does not plot other products data
        end
        if k==14 && i==1, a(i)=-1; continue, end %skipping over NoBF data for participant p
        pdata{i}(isnan(pdata{i}))=0; %if NaN exits in data, it is converted 0
        hold on
        if i==prod_num
            plot(pdata{i}(:,1),pdata{i}(:,3),[colors(i) 's:']) %plots participant data for all 5 products
            errorbar(pdata{i}(:,1),pdata{i}(:,3),(0.11505.*(pdata{i}(:,3)).^-0.24).*pdata{i}(:,3),[colors(i) 's:']);
        end       
       drawnow 
    end
%     drawnow
    xdata=pdata{prod_num}(:,1);
    ydata=pdata{prod_num}(:,3);
     
    if prod_num==1 && k==14, continue, end
    title(p{k})

    options = optimoptions(@lsqcurvefit,'FunctionTolerance',1e-10);
    [x,resnorm,residual,exitflag,output,lambda,J]=lsqcurvefit(@lsqfitfun,x0,xdata,ydata,lb,ub,options); 
    ci = nlparci(x,residual,'Jacobian',J,'alpha',.1);
    MSE = (residual'*residual)/(size(ydata,1)-size(x,2));
    CovMatrix =(J'*J)*MSE;
%%%% Calculating correlation matrix from covariance matrix:
    DiagCov = 1./sqrt(diag(CovMatrix));
    DiagCorr = spdiags(DiagCov,0,size(x,2),size(x,2));
    CorrMatrix = DiagCorr * CovMatrix * DiagCorr;
    FullCorrMatrix = full(CorrMatrix);
%%%% Saves data set
    dt=datestr(datetime('now'));
    dt(dt==':')='-'; %changes every colon in dt to a dash
    save([path 'presult_' p{k} '.mat'],...
        'x','resnorm','residual','exitflag','output','lambda','J','ci','MSE','CovMatrix','DiagCov',...
        'DiagCorr','CorrMatrix','FullCorrMatrix','xname')
    savefig([path 'presult_' p{k} '.fig']);

    hold off
end
toc  %tic toc tells time it took for model fitting